<?php

namespace LectorSOAP\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalCustomsValues StructType
 * @subpackage Structs
 */
class AdditionalCustomsValues extends AbstractStructBase
{
    /**
     * The AdditionalCustomsValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \LectorSOAP\StructType\AdditionalCustomsValue[]
     */
    public $AdditionalCustomsValue;
    /**
     * Constructor method for AdditionalCustomsValues
     * @uses AdditionalCustomsValues::setAdditionalCustomsValue()
     * @param \LectorSOAP\StructType\AdditionalCustomsValue[] $additionalCustomsValue
     */
    public function __construct(array $additionalCustomsValue = array())
    {
        $this
            ->setAdditionalCustomsValue($additionalCustomsValue);
    }
    /**
     * Get AdditionalCustomsValue value
     * @return \LectorSOAP\StructType\AdditionalCustomsValue[]|null
     */
    public function getAdditionalCustomsValue()
    {
        return $this->AdditionalCustomsValue;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalCustomsValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalCustomsValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalCustomsValueForArrayConstraintsFromSetAdditionalCustomsValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $additionalCustomsValuesAdditionalCustomsValueItem) {
            // validation for constraint: itemType
            if (!$additionalCustomsValuesAdditionalCustomsValueItem instanceof \LectorSOAP\StructType\AdditionalCustomsValue) {
                $invalidValues[] = is_object($additionalCustomsValuesAdditionalCustomsValueItem) ? get_class($additionalCustomsValuesAdditionalCustomsValueItem) : sprintf('%s(%s)', gettype($additionalCustomsValuesAdditionalCustomsValueItem), var_export($additionalCustomsValuesAdditionalCustomsValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalCustomsValue property can only contain items of type \LectorSOAP\StructType\AdditionalCustomsValue, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalCustomsValue value
     * @throws \InvalidArgumentException
     * @param \LectorSOAP\StructType\AdditionalCustomsValue[] $additionalCustomsValue
     * @return \LectorSOAP\StructType\AdditionalCustomsValues
     */
    public function setAdditionalCustomsValue(array $additionalCustomsValue = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalCustomsValueArrayErrorMessage = self::validateAdditionalCustomsValueForArrayConstraintsFromSetAdditionalCustomsValue($additionalCustomsValue))) {
            throw new \InvalidArgumentException($additionalCustomsValueArrayErrorMessage, __LINE__);
        }
        $this->AdditionalCustomsValue = $additionalCustomsValue;
        return $this;
    }
    /**
     * Add item to AdditionalCustomsValue value
     * @throws \InvalidArgumentException
     * @param \LectorSOAP\StructType\AdditionalCustomsValue $item
     * @return \LectorSOAP\StructType\AdditionalCustomsValues
     */
    public function addToAdditionalCustomsValue(\LectorSOAP\StructType\AdditionalCustomsValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LectorSOAP\StructType\AdditionalCustomsValue) {
            throw new \InvalidArgumentException(sprintf('The AdditionalCustomsValue property can only contain items of type \LectorSOAP\StructType\AdditionalCustomsValue, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalCustomsValue[] = $item;
        return $this;
    }
}
