<?php

namespace LectorSOAP\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalProductAttributes StructType
 * @subpackage Structs
 */
class AdditionalProductAttributes extends AbstractStructBase
{
    /**
     * The AdditionalProductAttribute
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \LectorSOAP\StructType\AdditionalProductAttribute[]
     */
    public $AdditionalProductAttribute;
    /**
     * Constructor method for AdditionalProductAttributes
     * @uses AdditionalProductAttributes::setAdditionalProductAttribute()
     * @param \LectorSOAP\StructType\AdditionalProductAttribute[] $additionalProductAttribute
     */
    public function __construct(array $additionalProductAttribute = array())
    {
        $this
            ->setAdditionalProductAttribute($additionalProductAttribute);
    }
    /**
     * Get AdditionalProductAttribute value
     * @return \LectorSOAP\StructType\AdditionalProductAttribute[]|null
     */
    public function getAdditionalProductAttribute()
    {
        return $this->AdditionalProductAttribute;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalProductAttribute method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalProductAttribute method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalProductAttributeForArrayConstraintsFromSetAdditionalProductAttribute(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $additionalProductAttributesAdditionalProductAttributeItem) {
            // validation for constraint: itemType
            if (!$additionalProductAttributesAdditionalProductAttributeItem instanceof \LectorSOAP\StructType\AdditionalProductAttribute) {
                $invalidValues[] = is_object($additionalProductAttributesAdditionalProductAttributeItem) ? get_class($additionalProductAttributesAdditionalProductAttributeItem) : sprintf('%s(%s)', gettype($additionalProductAttributesAdditionalProductAttributeItem), var_export($additionalProductAttributesAdditionalProductAttributeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalProductAttribute property can only contain items of type \LectorSOAP\StructType\AdditionalProductAttribute, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalProductAttribute value
     * @throws \InvalidArgumentException
     * @param \LectorSOAP\StructType\AdditionalProductAttribute[] $additionalProductAttribute
     * @return \LectorSOAP\StructType\AdditionalProductAttributes
     */
    public function setAdditionalProductAttribute(array $additionalProductAttribute = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalProductAttributeArrayErrorMessage = self::validateAdditionalProductAttributeForArrayConstraintsFromSetAdditionalProductAttribute($additionalProductAttribute))) {
            throw new \InvalidArgumentException($additionalProductAttributeArrayErrorMessage, __LINE__);
        }
        $this->AdditionalProductAttribute = $additionalProductAttribute;
        return $this;
    }
    /**
     * Add item to AdditionalProductAttribute value
     * @throws \InvalidArgumentException
     * @param \LectorSOAP\StructType\AdditionalProductAttribute $item
     * @return \LectorSOAP\StructType\AdditionalProductAttributes
     */
    public function addToAdditionalProductAttribute(\LectorSOAP\StructType\AdditionalProductAttribute $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LectorSOAP\StructType\AdditionalProductAttribute) {
            throw new \InvalidArgumentException(sprintf('The AdditionalProductAttribute property can only contain items of type \LectorSOAP\StructType\AdditionalProductAttribute, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalProductAttribute[] = $item;
        return $this;
    }
}
